version: '3.2'
services:
  db:
    image: 'postgres:15.3'
    environment:
      POSTGRES_DB: 'soniksnetwork'
      POSTGRES_USER: 'soniksnetwork'
      POSTGRES_PASSWORD: 'soniksnetwork'
      POSTGRES_ROOT_PASSWORD: 'toor'
    #command: ['--character-set-server=utf8mb4', '--collation-server=utf8mb4_unicode_ci']
    restart: 'on-failure'
    volumes:
      - type: 'volume'
        source: 'db'
        target: '/var/lib/postgresql'
    ports:
      - '5432:5432'
  redis:
    image: 'redis:5.0.7'
    restart: 'on-failure'
    command: 'redis-server --appendonly yes'
    volumes:
      - type: 'volume'
        source: 'redis'
        target: '/data'
  celery:
    build:
      context: '.'
    depends_on:
      - 'db'
      - 'redis'
    environment:
      PYTHONDONTWRITEBYTECODE: '1'
      DATABASE_URL: 'postgres://soniksnetwork:soniksnetwork@db/soniksnetwork'
      CELERY_BROKER_URL: 'redis://redis:6379/0'
      CELERY_RESULT_BACKEND: 'redis://redis:6379/0'
      CACHE_BACKEND: 'django.core.cache.backends.redis.RedisCache'
      CACHE_LOCATION: 'redis://redis:6379/1'
      MEDIA_ROOT: '/var/lib/soniks-network/media'
    command: ["djangoctl.sh", "develop_celery", "/usr/local/src/soniks-network"]
    restart: 'on-failure'
    volumes:
      - '.:/usr/local/src/soniks-network:z'
      - type: 'volume'
        source: 'media'
        target: '/var/lib/soniks-network/media'
  web:
    build:
      context: '.'
    image: 'registry.gitlab.com/space-education-development/soniks/soniks-network/soniks-network:soniks'
    ports:
      - '8000:8000'
    depends_on:
      - 'db'
      - 'redis'
    environment:
      PYTHONDONTWRITEBYTECODE: '1'
      DATABASE_URL: 'postgres://soniksnetwork:soniksnetwork@db/soniksnetwork'
      CELERY_BROKER_URL: 'redis://redis:6379/0'
      CELERY_RESULT_BACKEND: 'redis://redis:6379/0'
      CACHE_BACKEND: 'django.core.cache.backends.redis.RedisCache'
      CACHE_LOCATION: 'redis://redis:6379/1'
      STATIC_ROOT: '/var/lib/soniks-network/staticfiles'
      MEDIA_ROOT: '/var/lib/soniks-network/media'
    command: ["djangoctl.sh", "develop", "/usr/local/src/soniks-network"]
    restart: 'on-failure'
    volumes:
      - '.:/usr/local/src/soniks-network:z'
      - type: 'volume'
        source: 'static'
        target: '/var/lib/soniks-network/staticfiles'
      - type: 'volume'
        source: 'media'
        target: '/var/lib/soniks-network/media'
volumes:
  db:
  redis:
  static:
  media:
